Update credit status by order number - Fabric

Update credit status by order number

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/update-credit-status \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-channel-id: <x-fabric-channel-id>' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "creditId": "a05b72dc-78d8-4ea4-90fc-2fe6a1fe1111",
  "statusCode": "PENDING",
  "attributes": {
    "giftCardNumber": "XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ"
  },
  "note": "Credit request initiated"
}
'

Python Example

import requests

url = "https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/update-credit-status"

payload = {
    "creditId": "a05b72dc-78d8-4ea4-90fc-2fe6a1fe1111",
    "statusCode": "PENDING",
    "attributes": { "giftCardNumber": "XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ" },
    "note": "Credit request initiated"
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "x-fabric-channel-id": "<x-fabric-channel-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript Example

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    'x-fabric-channel-id': '<x-fabric-channel-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    creditId: 'a05b72dc-78d8-4ea4-90fc-2fe6a1fe1111',
    statusCode: 'PENDING',
    attributes: {giftCardNumber: 'XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ'},
    note: 'Credit request initiated'
  })
};

fetch('https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/update-credit-status', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP Example

<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/update-credit-status",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'creditId' => 'a05b72dc-78d8-4ea4-90fc-2fe6a1fe1111',
    'statusCode' => 'PENDING',
    'attributes' => [
        'giftCardNumber' => 'XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ'
    ],
    'note' => 'Credit request initiated'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-channel-id: <x-fabric-channel-id>",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>

Java Example

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/update-credit-status"

payload := strings.NewReader("{\n  \"creditId\": \"a05b72dc-78d8-4ea4-90fc-2fe6a1fe1111\",\n  \"statusCode\": \"PENDING\",\n  \"attributes\": {\n    \"giftCardNumber\": \"XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ\"\n  },\n  \"note\": \"Credit request initiated\"}\n")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("x-fabric-channel-id", "<x-fabric-channel-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

HTTP Response Codes

200

400

401

404

500


Response Example

{
  "amount": 21.5,
  "currency": "USD",
  "reasonCode": "EC",
  "source": "CSR",
  "type": "GIFT_CARD",
  "amountInCurrencies": [
    {
      "currency": "USD",
      "group": "SHOPPER",
      "amount": 123.45
    }
  ],
  "attributes": {
    "giftCardNumber": "XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ"
  },
  "createdAt": "2022-07-11T15:03:14.642Z",
  "creditId": "a05b72dc-78d8-4ea4-90fc-2fe6a1fe1111",
  "employeeId": "12312232",
  "note": "Credit request initiated",
  "paymentCounter": 1,
  "policyCode": "RC1",
  "statusCode": "PENDING",
  "subReasonCode": "ACC",
  "updatedAt": "2022-07-11T15:03:14.642Z"
}

Error Responses

{
  "errors": [
    {
      "message": "Invalid request",
      "type": "CLIENT_ERROR"
    }
  ],
  "message": "Bad request",
  "type": "CLIENT_ERROR"
}
{
  "message": "Unauthorized request",
  "type": "CLIENT_ERROR"
}
{
  "message": "Not found",
  "type": "CLIENT_ERROR"
}
{
  "message": "Internal server error",
  "type": "SERVER_ERROR"
}

Authorization

Bearer Authentication